const puppeteer = require('puppeteer');
async function mistelanea() {
    //const browser = await puppeteer.launch(); esto funciona local
    const browser = await puppeteer.launch({
        ignoreDefaultArgs: ['--disable-extensions'],
        headless:true,
        args:['--no-sandbox']
      });
    const page = await browser.newPage();
    let index = [
    ['tés aromatizados', 'https://mistelanea.com/46-tes-aromatizados-a-granel-en-hoja', '120'],
    ['puros', 'https://mistelanea.com/45-tes-puros-en-hoja-a-granel', '48'],
    ['rooibos', 'https://mistelanea.com/55-tes-verdes-aromatizados'],
    ['infusiones', 'https://mistelanea.com/9-Infusiones-naturales-a-granel', '48'],
    ['accesorios','https://mistelanea.com/21-accesorios-para-te-e-infusiones#/', '120'],
    ['colecciones', 'https://mistelanea.com/37-packs-exclusivos-tes-variados-ideales-para-regalar'],
    ['alimentacion', 'https://mistelanea.com/31-para-acompanar-con-el-te-galletas-dulces-pastas', '48']];
    var te_string =''
    var final = ''
    var categoria = ''
    for (var j = 0;j<index.length; j++)
    {     
        await page.goto(index[j][1], {waitUntil: 'domcontentloaded'});
        if(index[j][0] != 'colecciones' && index[j][0] != 'rooibos'){
                page.waitForSelector("select#nb_item");
                await page.select('[name = "n"]', index[j][2]);
                await page.waitFor(2000)
        }
        await page.waitFor(2000)
        categoria = index[j][0];
        const brebajes = await page.evaluate((categoria, te_string) =>{
            const productos_raw = document.getElementsByClassName("product-name")
            const precios_raw = document.getElementsByClassName("price product-price")
            var productos = []
            var precios = []
            for(var i = 1; i<productos_raw.length; i++){
                productos.push(productos_raw[i].innerText)
            }
            for(var i = 0; i<precios_raw.length; i++){
                aux = precios_raw[i].innerText
                aux = aux.replace(",", ".")
                aux = aux.replace(" €", "")//revisar com a outra forma
                precios.push(aux)
            }
            te_string += '"'+categoria+'":['
            for (var i = 0; i< productos.length; i++){
                te_string += '{"producto":"'+productos[i]+'", "precio":'+precios[i]+'}'
                if(i< productos.length - 1){
                    te_string += ","
                }
            }            
            te_string += '],';
            return te_string;
        }, categoria, te_string)
        final += brebajes 
    }
    final = '{' + final
    final = final.replace("'", "")
    final = final.slice(0, final.length - 1) + '}'

    var obj = JSON.parse(JSON.stringify(final));
    if(final.indexOf('argando')>0){
        console.log("ha habido un error haciendo el fetch de productos de mistelanea")
    }
    if (final.indexOf('colecciones') > 0){
        console.log('mistelanea ha sido violada correctamente')
    }
    await browser.close()


    return obj;
}

module.exports.mistelanea = mistelanea;
