const sqlite3 = require("sqlite3").verbose()

const dbRoute = '/root/tea_project/rascunhos.db';

async function mistelaneaProvDb(){
    const db = new sqlite3.Database(dbRoute, err =>{
        console.log("problems opening the db")
        console.log("*******************")
        console.log(err)
    })
    return new Promise(resolve =>{
        db.all("SELECT DISTINCT * FROM mistelanea;",(err, rows) =>{
            if(err){
                console.log("There was a problem during the query from mistelanea")
                console.log(err)
            }
           
            resolve(rows)
        })
    })
    db.close();
}

module.exports.mistelaneaProvDb = mistelaneaProvDb